import sys
import signal
import string

import netsvc
import netsvc.xmlrpc

count = len(sys.argv)-1
server = None
domain = ""
port = None
group = "PUBLIC"

args = sys.argv[1:]

def usage():
  print "Usage: xmlrpc-gateway -connect server " \
      "[ -domain name ] -listen port [ -group name ]"

try:
  i = 0
  while i < count:
    if args[i] == "-connect":
      server = args[i+1]
      i = i + 2
    elif args[i] == "-group":
      group = args[i+1]
      i = i + 2
    elif args[i] == "-listen":
      port = int(args[i+1])
      i = i + 2
    elif args[i] == "-domain":
      domain = args[i+1]
      i = i + 2
    else:
      usage()
      sys.exit(1)
except:
  usage()
  sys.exit(1)

if server == None or port == None:
  usage()
  sys.exit(1)

dispatcher = netsvc.Dispatcher()
dispatcher.monitor(signal.SIGINT)

httpd = netsvc.HttpDaemon(port)
rpcgw = netsvc.xmlrpc.RpcGateway(group)
httpd.attach("/",rpcgw)
httpd.start()

exchange = netsvc.Exchange(netsvc.EXCHANGE_CLIENT,domain)

delay = 5
host,port = string.splitfields(server,':')
port = int(port)
exchange.connect(host,port,delay)

dispatcher.run()
